Feature: Documentation Generator

  Scenario: Build empty app
    Given an empty app
    When I run `roxie`
    Then was successfully generated
    Then the docs should not contain "tags:"

  Scenario: Build empty app with alias `d`
    Given an empty app
    When I run `roxie d`
    Then was successfully generated

  Scenario: Build empty app with custom output
    Given an empty app
    When I successfully run `roxie -o documentation/reference.json`
    Then the following files should exist:
      | documentation/reference.json                        |

  Scenario: Build mixed app with default options
    Given I successfully generate "mixed" with `roxie **/*`
    Then the docs should contain "index.coffee"
    And the docs should not contain "This line should not be documented"
    And the docs should contain '"type": "module"'

  Scenario: Build mixed app with only multi-line comments
    Given I successfully generate "mixed" with `roxie **/* --only-multi`
    Then the docs should contain "index.coffee"
    And the docs should not contain "single line"

  Scenario: Build mixed app with only single-line comments
    Given I successfully generate "mixed" with `roxie **/* --only-single`
    Then the docs should contain "index.coffee"
    And the docs should contain "single line"

  Scenario: Build multi-language app with only tagged comments
    Given I successfully generate "multi-language" with `roxie **/* --only-tagged`
    Then the docs should contain "utils.js"
    Then the docs should contain "functions.scss"
    And the docs should not contain "test.coffee"
    And the docs should not contain "default.css"

  Scenario: Build app with fallback language
    Given I successfully generate "incorrect-extensions" with `roxie **/* -l JavaScript`
    Then the docs should contain "utils.javascripty"
    Then the docs should contain "global.css"

  Scenario: Build app with specified base path
    Given I successfully generate "specific-base" with `roxie hello_world.rb --base-path codebase`
    Then the docs should contain "hello_world.rb"

  Scenario: Build app with excludes
    Given I successfully generate "ignores" with `roxie **/*.js -x ignore`
    Then the docs should not contain "ignore"

  Scenario: Build app with EOL comments
    Given I successfully generate "eol" with `roxie **/*.js --only-single`
    Then the docs should not contain '"line":'

  Scenario: Build app with errors
    Given a fixture app "doomed"
    When I run `roxie **/*.js`
    Then the exit status should be 1
