require 'fileutils'

Given /^an empty app$/ do
  step %Q{a directory named "empty_app"}
  step %Q{I cd to "empty_app"}
end

Given /^was successfully generated$/ do
  step %Q{a directory named "doc" should exist}
  step %Q{the exit status should be 0}
end

Given /^was unsuccessfully generated$/ do
  step %Q{the exit status should be 1}
end

Given /^a fixture app "([^\"]*)"$/ do |path|
  # This step can be reentered from several places but we don't want
  # to keep re-copying and re-cd-ing into ever-deeper directories
  next if File.basename(current_dir) == path

  step %Q{a directory named "#{path}"}

  target_path = File.join(PROJECT_ROOT_PATH, "fixtures", path)
  FileUtils.cp_r(target_path, current_dir)

  step %Q{I cd to "#{path}"}
end

Given /^I successfully generate "([^\"]*)" with `(.*?)`$/ do |path, cmd|
  step %Q{a fixture app "#{path}"}
  step %Q{I run `#{cmd}`}
  step %Q{was successfully generated}
end

# Provide these Aruba overload in case we're matching something with quotes in it
Then /^the file "([^"]*)" should contain '([^']*)'$/ do |file, partial_content|
  check_file_content(file, partial_content, true)
end

Then /^the file "([^"]*)" should not contain '([^']*)'$/ do |file, partial_content|
  check_file_content(file, partial_content, false)
end

Then /^the docs should contain "(.*?)"$/ do |partial_content|
  step %Q{the file "doc/api.json" should contain "#{partial_content}"}
end

Then /^the docs should contain '([^']*)'$/ do |partial_content|
  step %Q{the file "doc/api.json" should contain '#{partial_content}'}
end

Then /^the docs should not contain "(.*?)"$/ do |partial_content|
  step %Q{the file "doc/api.json" should not contain "#{partial_content}"}
end

Then /^the docs should not contain '([^']*)'$/ do |partial_content|
  step %Q{the file "doc/api.json" should not contain '#{partial_content}'}
end
