require 'spec_helper'

def file(name)
  File.read(File.join(Roxie::ROOT, 'roxie', name))
end

def assert_sorted(list)
  previous = nil
  list.each do |item|
    if previous
      expect(previous).to be < item
    end
    previous = item
  end
end

describe "Support languages" do
  it "should be listed alphabetically" do
    languages = []
    file("languages.yml").lines.each do |line|
      if line =~ /^([a-zA-Z][\w+\-\# ]*):$/
        languages << $1.downcase
      end
    end
    assert_sorted languages
  end
end
